package org.openxma.dsl.generator.helper;

import java.util.ArrayList;
import java.util.List;

import org.openxma.dsl.core.model.ParameterValue;
import org.openxma.dsl.core.model.ReferenceWithParameter;

public class ParameterValueCollector {
		
	private boolean moreRequired=true;
	private List<ParameterValueRecord> list = new ArrayList<ParameterValueRecord>();
	private List<String> stringValueList = null;	
	
	public void addParameterValues(ParameterValueRecord record) {
		if (record != null) {
			list.add(record);
			for (ParameterValue value : record.getValidatorParameters()) {
				if (value.isKeepParentValue()) return;
			}
		}
		moreRequired = false;
	}

	public boolean isMoreRequired() {
		return moreRequired;
	}
	
	public int getParameterCount() {
		return list.size();
	}
	
	public String getParameterValueString(int index) {
		String string = WidgetExtension.getValueForIndex(getParameterValuesAsStringList(),index);
		return string;
	}
	
	private List<String> getParameterValuesAsStringList() {
		if (stringValueList == null) {
			stringValueList = new ArrayList<String>();
			if (list.size()>0) {
				int parCount = (list.get(0).getValidatorParameters() != null) ? list.get(0).getValidatorParameters().size() : 0;
				for (int i=0;i<parCount;i++) {
					String string = null;
					for (ParameterValueRecord pvr : list) {
						if (pvr.getValidatorParameters().size()>i) {
							ParameterValue pv = pvr.getValidatorParameters().get(i);
							if (pv.isKeepParentValue()) continue;
							string = WidgetExtension.getParameterValue(pv,pvr.getDefinitionStack(),pvr.getDefinitionStack().size()-1);						
							break;
						}
					}
					stringValueList.add(string);
				}
			}
		}
		return stringValueList;
	}	
}

class ParameterValueRecord {
	
	private List<ParameterValue> parameterValues;
	private List<ReferenceWithParameter> definitionStack;
	
	public List<ParameterValue> getValidatorParameters() {
		return parameterValues;
	}

	public List<ReferenceWithParameter> getDefinitionStack() {
		return definitionStack;
	}

	public ParameterValueRecord(List<ParameterValue> parameterValues, List<ReferenceWithParameter> definitionStack) {
		this.parameterValues = parameterValues;
		this.definitionStack = definitionStack;		
	}	
}

